import struct

# Read Thingy table
thingy_table = {}
with open('Puyo Puyo Fever.tbl', 'r', encoding='utf-8') as f:
    for line in f:
        if line.startswith('#'):
            continue
        key, value = line.strip().split('=', 1)
        thingy_table[key] = value

# Read hex file
with open('hex_file.bin', 'rb') as f:
    f.seek(0x02)
    offset = struct.unpack('<H', f.read(2))[0] * 2
    f.seek(offset)
    bytes_pair = f.read(2)
    output = ''
    while bytes_pair:
        value = struct.unpack('>H', bytes_pair)[0]
        hex_string = hex(value)[2:].zfill(4).upper()
        key = hex_string[:2] + hex_string[2:]
        if value == 0x2801 or value == 0x2901 or value == 0xF200: # [Brackets] and $Dollar Sign
            output += "\\"
        if value == 0x0080: # Space
            output += " "
        if key in thingy_table:
            output += f"{thingy_table[key]}"
        else:
            output += f"${hex_string}"
        if value == 0xFFFF:
            output += '\n'
        bytes_pair = f.read(2)

file = open("text_file.txt", "w")
file.write(output)
file.close()
print(output)
